local BGCF = {}

-- Player Data, indexed on GUID
local PD

-- Node Data, indexed on "real" nodeID
local ND

if not BGCFramePublic then BGCFramePublic = {} end

function BGCFramePublic.Reset()
	PD = {}
	ND = {}
end

function BGCFramePublic.PlayerAt(guid,nodeID,isHealer)
	if not PD[guid] then PD[guid] = {} end
	local p = PD[guid]
	
	if p.lastNode then
		BGCF.RemovePlayerFromNode(p.lastNode,p.isHealer)
	end
	BGCF.AddPlayerToNode(nodeID,isHealer)
	p.lastNode = p.node
	p.node = nodeID
	if not p.isHealer and isHealer then p.isHealer = isHealer end
end

function BGCF.RemovePlayerFromNode(nodeID,isHealer)
	local n = ND[nodeID]
	if isHealer then
		n.heal = n.heal - 1
	else
		n.damage = n.damage - 1
	end	
	UpdatePlayers(nodeID)
end

function BGCF.AddPlayerToNode(nodeID,isHealer)
	if not ND[nodeID] then
		local name, description = GetMapLandmarkInfo(i)
		ND[nodeID].name = name
		ND[nodeID].description = description
	end
	local n = ND[nodeID]
	if isHealer then
		n.heal = n.heal + 1
	else
		n.damage = n.damage + 1
	end
	UpdatePlayers(nodeID)
end

function BGCF.UpdatePlayers(nodeID)
	-- TOOD: HOW DO I DO THIS
end

function BGCF_OnLoad(self)
	self:SetScript("OnEvent",BGCF.OnEvent);
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterForDrag("LeftButton");
	self:Hide()
	self:SetParent(nil)
end

function BGCF.OnClick(self)

end


function BGCF_OnDragStart(self)
	print("Drag start")
	if BGCF.IsMovable() then
		print("Movable")
		self:StartMoving();	
	end
end

function BGCFLock_OnClick(self)
	BG_Control_SV.Options.MoveFrame = nil;
	BGCFramePublic.EvaluateLockButton();
end

function BGCF_OnDragStop(self)
	print("DragStop")
	self:StopMovingOrSizing();
end

function BGCF.IsMovable()
	return not InCombatLockdown() and BG_Control_SV.Options
.MoveFrame
end

function BGCFramePublic.EvaluateLockButton()
	if not BG_Control_SV.Options.MoveFrame and BG_ControlLock:IsShown() then
		BG_ControlLock:Hide()
	elseif BG_Control_SV.Options.MoveFrame and not BG_ControlLock:IsShown() then
		BG_ControlLock:Show()
	end
end

function BGCF.Addon_Loaded(self,...)
	local name = ...
	if "BG_Control" == name then
		print("Loaded BG_Control frames")
		self:UnregisterEvent("ADDON_LOADED");
		BGCFramePublic.EvaluateLockButton();

		-- Cleanup
		BGCF.OnEvent = nil
		BGCF.Addon_Loaded = nil
	end
end

function BGCF.OnEvent(self, event, ...)
	if "ADDON_LOADED" == event then
		BGCF.Addon_Loaded(self,...)
	end
end
